// Atari Interlaced Studio -> MCP 160x200

// AUDF4 = 1 -> IRQ line x2

// IRQ split colors  ($0264 free proc cycles) !!! FAST !!!

// 255*23 + 27  (256*) = 5892 * 2 + 2300  = 14084 free CPU cycle

// 07.06.2015


	opt l-
	icl 'atari.hea'
	opt l+


height	 = 100

buf0	= $2010
buf1	= $4010

/*-------------------------------------------------------------------------------------------------*/

	org $80

regA	.ds 1
regX	.ds 1
regY	.ds 1
cnt	.ds 1
line	.ds 1
time	.ds 2

/*-------------------------------------------------------------------------------------------------*/

	.get 'monster.dat',-9		; palette

/*-------------------------------------------------------------------------------------------------*/

	org buf0
	ins 'monster.dat',0,8000

	org buf1
	ins 'monster.dat',$2800,8000

/*-------------------------------------------------------------------------------------------------*/

		.align $100
	dlist0:	dta d'pp',$10+$80
		dta $10				; 2 linie dla pierwszej zmiany koloru przez IRQ
		:200 dta $4e,a(buf0+#*40)
		dta $41,a(dlist1)

		.align $200
	dlist1:	dta d'pp',$10+$80
		dta $10
		:200 dta $4e,a(buf1+#*40)
		dta $41,a(dlist0)

/*-------------------------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------------------------*/

main	lda:cmp:req 20

	sei

	mva	#$00	nmien
	sta	irqen

	sta time
	sta time+1

	mva #height line
	
	mva	#$fe	portb

	mwa	#dlist0	dlptr		; poczatkowa klatka, potem juz ANTIC bedzie przelaczal katki

	mwa	#NMI	$fffa
	mwa	#irq	$fffe		; setup custom IRQ handler

	mva	#3	SKCTL

	mva	#1	AUDCTL		; 0=POKEY 64KHz, 1=15KHz

	mva	#0	AUDC4		; test - no polycounters + volume only
	mva	#1	AUDF4		; ~64KHz clock 16 = ~4Khz timer, ~15KHz clock 4 = ~4KHz

	mva	#$c0	nmien
	cli


loop	jsr delay
	inw time

	jmp loop

delay	rts
	
/*
	lda:rne vcount

wait	lda skctl			; press any key
	and #4
	bne wait

	lda:rne vcount

	mva	#$ff	portb
	mva	#$40	nmien
	cli

	mva #$ff 764			; clear info about pressed key
	rts				; exit
*/

/*-------------------------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------------------------*/

	.align

IRQ	.local
	sta regA

_1	mva #.get[5] color0
	mva #.get[6] color1
	mva #.get[7] color2

	mva #0 IRQEN
	mva #4 IRQEN

	#cycle #13

	dec line
	beq IRQstop

	mva #.get[1] color0
	mva #.get[2] color1
	mva #.get[3] color2

	lda regA
	rti
	.endl


IRQstop	mva #0 IRQEN

	lda regA
	rti


IRQ2	.local
	sta regA

_1	mva #.get[1] color0
	mva #.get[2] color1
	mva #.get[3] color2

	mva #0 IRQEN
	mva #4 IRQEN

	#cycle #13

	dec line
	beq IRQstop

	mva #.get[5] color0
	mva #.get[6] color1
	mva #.get[7] color2

	lda regA
	rti
	.endl


NMI	bit nmist
	bpl vbl


dli0	sta rA

	lda #4
	sta wsync
	sta stimer
	sta irqen

	lda #0
rA	equ *-1
	rti


vbl	sta nmist
	phr

	mva #scr40	dmactl

	mva #height line
	
	lda #1
sw	equ *-1
	eor #1
	sta sw
	beq _0

	mwa #irq2 $fffe
	bne skp
	
_0	mwa #irq $fffe

skp
	mva #.get[0]	colbak
	mva #.get[1]	color0
	mva #.get[2]	color1
	mva #.get[3]	color2	

	mwa time $600
	mwa #0 time

	plr
	rti

/*-------------------------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------------------------*/

	run main
